%define confdir %{_sysconfdir}/cvsupd
%define logdir /var/log/cvsupd
%define m3name ezm3
%define m3ver 1.1
%define snapver 16.1h

Summary: CVS-Optimized General-Purpose Network File Distribution System client
Name: cvsup
Version: 16.1
Release: 0.fdr.6.h.2
Epoch: 0
URL: http://www.polstra.com/projects/freeware/CVSup/
License: BSD
Group: Applications/Internet
Source0: ftp://ftp.freebsd.org/pub/FreeBSD/development/CVSup/sources/cvsup-snap-16.1h.tar.gz
Source1: cvsupd.rc
Source2: cvsupd.logrotate
Source3: cvsupd.conf
Source4: ftp://ftp.freebsd.org/pub/FreeBSD/development/CVSup/ezm3/ezm3-1.1-src.tar.bz2
Source5: ftp://ftp.freebsd.org/pub/FreeBSD/development/CVSup/ezm3/ezm3-1.1-LINUXLIBC6-boot.tar.bz2
Patch0: cvsup-contrib.patch
Patch1: cvsup-no-rpath.diff
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: mktemp, sed, XFree86-devel, zlib-devel

%package -n cvsup-contrib
Summary: CVSup user contributed helper tools
Group: Development/Tools

%package -n cvsupd
Summary: CVS-Optimized General-Purpose Network File Distribution System server
Group: Development/Tools
Requires: initscripts, logrotate
Requires(post): chkconfig
Requires(preun): chkconfig

%description -n cvsup
CVSup is a software package for distributing and updating collections
of files across a network. It can efficiently and accurately mirror
all types of files, including sources, binaries, hard links, symbolic
links, and even device nodes. CVSup's streaming communication protocol
and multithreaded architecture make it most likely the fastest
mirroring tool in existence today.

This package contains the cvsup client program and cvpasswd utility.

%description -n cvsup-contrib
CVSup is a software package for distributing and updating collections
of files across a network. It can efficiently and accurately mirror
all types of files, including sources, binaries, hard links, symbolic
links, and even device nodes. CVSup's streaming communication protocol
and multithreaded architecture make it most likely the fastest
mirroring tool in existence today.

This package contains the cvsup user contributed helper tools.

%description -n cvsupd
CVSup is a software package for distributing and updating collections
of files across a network. It can efficiently and accurately mirror
all types of files, including sources, binaries, hard links, symbolic
links, and even device nodes. CVSup's streaming communication protocol
and multithreaded architecture make it most likely the fastest
mirroring tool in existence today.

This package contains the cvsupd server program.

%prep

%setup -q -n %{name}-snap-%{snapver}
%setup -q -T -D -a 4 -n %{name}-snap-%{snapver}
%setup -q -T -D -a 5 -n %{name}-snap-%{snapver}

%patch
%patch1 -p1


%build
# ------------------------- Begin hackery ------------------------- #
# This is woeful hackery to build and install ezm3 locally, thereby avoiding
# an ezm3 build requirement.  The reason I'm doing this is:
#     1) The only reason to have ezm3 is to build cvsup
#     2) ezm3 can't install to a buildroot, which means you have to
#        install as root to your running system, which I dislike
# This does add a mktemp build requirement, but I'm ok with that. :-P
# This is basically lifted from the SuSE 8.1 RPM -- cvsup-16.1f-94.src.rpm
m3dir="$(pwd)/m3"
PATH="$PATH:${m3dir}/bin"
TMPFILE=$(mktemp -q /tmp/%{m3name}.XXXXXX)
if [ $? -ne 0 ]; then
    echo "$0: Can’t create temp file, exiting..."
    exit 1
fi
sed -e "s|INSTALL_ROOT.*|INSTALL_ROOT = \"${m3dir}\"|" \
    < %{m3name}-%{m3ver}/m3config/src/LINUXLIBC6 > $TMPFILE
mv $TMPFILE %{m3name}-%{m3ver}/m3config/src/LINUXLIBC6
(cd %{m3name}-%{m3ver}; make BISON=yacc)
# ------------------------- End hackery ------------------------------ #
# Now build cvsup -- whew!
make PREFIX=%{_prefix} %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
# all packages
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man1
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man8
install -d -m 755 $RPM_BUILD_ROOT%{_sbindir}
make install PREFIX=$RPM_BUILD_ROOT%{_prefix} MANDIR=$RPM_BUILD_ROOT%{_mandir}
# cvsup-contrib sub-package
install -m 755 \
    $RPM_BUILD_DIR/%{name}-snap-%{snapver}/contrib/cvsup2html/cvsup2html.awk \
    $RPM_BUILD_ROOT%{_bindir}
install -m 755 \
    $RPM_BUILD_DIR/%{name}-snap-%{snapver}/contrib/cvsup2httplog/cvsup2httplog \
    $RPM_BUILD_ROOT%{_bindir}
install -m 755 \
    $RPM_BUILD_DIR/%{name}-snap-%{snapver}/contrib/cvsupchk/cvsupchk \
    $RPM_BUILD_ROOT%{_bindir}
install -m 755 \
    $RPM_BUILD_DIR/%{name}-snap-%{snapver}/contrib/cvsuplog2html/cvsuplog2html \
    $RPM_BUILD_ROOT%{_bindir}
install -m 755 \
    $RPM_BUILD_DIR/%{name}-snap-%{snapver}/contrib/cvsupwho/cvsupwho \
    $RPM_BUILD_ROOT%{_bindir}
# cvsupd sub-package
install -d -m 755 $RPM_BUILD_ROOT%{confdir}/sup
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{confdir}
install -d -m 755 $RPM_BUILD_ROOT%{_initrddir}
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_initrddir}/cvsupd
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/cvsupd
install -d -m 755 $RPM_BUILD_ROOT%{logdir}

%post -n cvsupd
/sbin/chkconfig --add cvsupd

%clean
rm -rf $RPM_BUILD_ROOT

%preun -n cvsupd
if [ $1 = 0 ]; then
    # if $1 is 0 (no remaining arguments left to run) we are uninstalling
    /sbin/chkconfig --del cvsupd
    if [ -f /var/lock/subsys/cvsupd ]; then
        %{_initrddir}/cvsupd stop
    fi
else
    # if $1 is not zero then this is an upgrade
    %{_initrddir}/cvsupd condrestart
fi

%files -n cvsup
%defattr(-,root,root)
%{_bindir}/cvpasswd
%{_bindir}/cvsup
%{_mandir}/man1/cvsup.1.gz
%{_mandir}/man1/cvpasswd.1.gz
%doc Acknowledgments Announce Blurb ChangeLog Install License doc examples

%files -n cvsup-contrib
%defattr(-,root,root)
%{_bindir}/cvsup2html.awk
%{_bindir}/cvsup2httplog
%{_bindir}/cvsupchk
%{_bindir}/cvsuplog2html
%{_bindir}/cvsupwho
%doc Acknowledgments Announce Blurb ChangeLog Install License contrib doc examples

%files -n cvsupd
%defattr(-,root,root)
%dir %{confdir}
%config(noreplace) %{confdir}/cvsupd.conf
%dir %{confdir}/sup
%config(noreplace) %{_sysconfdir}/logrotate.d/cvsupd
%config(noreplace) %{_initrddir}/cvsupd
%{_sbindir}/cvsupd
%{_mandir}/man8/cvsupd.8.gz
%attr(755,nobody,nobody) %dir %{logdir}
%doc Acknowledgments Announce Blurb ChangeLog Install License doc examples

%changelog
* Sun Apr 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:16.1-0.fdr.6.h
- Split (post,preun) into two to work around a bug in rpm.

* Wed Mar 17 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:16.1-0.fdr.5.h
- Disable RPATH (patch from SuSE 9.0).
  http://www.securityfocus.com/archive/1/351758/2004-01-27/2004-02-02/0

* Fri May 02 2003 Jason Corley <jason.corley@borland.com> 0:16.1-0.fdr.4.h
- Fix Source tags to be full URLs for CVSup and ezm3

* Wed Apr 30 2003 Jason Corley <jason.corley@borland.com> 0:16.1-0.fdr.3.h
- Fixed various Requires based on input from Adrian Reber
- Removed unnecessary rm in prep

* Mon Apr 28 2003 Jason Corley <jason.corley@borland.com> 0:16.1-0.fdr.2.h
- More Fedora related cleanups
- Make contrib files in _bindir mode 755
- Move snapshot letter revision "h" out of version to meet Fedora standards
- Add macro snapver due to version change

* Tue Apr 22 2003 Jason Corley <jason.corley@borland.com> 0:16.1h-0.fdr.1
- Updated to 16.1h snapshot
- Attempt to comply with Fedora packaging standards

* Wed Mar 19 2003 Jason Corley <Jason.Corley@Borland.com>
- Updated to 16.1g snapshot
- Fixed up the documentation

* Tue Jan 14 2003 Jason Corley <Jason.Corley@TogetherSoft.com>
- Added better defined dependencies for building and installing
- Added config file for tweaking the init script
- Set cvsupd to run as unpriviledged user nobody
- Fixed up preun section of cvsupd package to check whether it was an uninstall
  or an upgrade
- Added post section for chkconfig adding of cvsupd
- Removed checkouts.log from package
- Removed static build messiness
- Added cvsup-contrib package so users could install contrib tools
- Added patch to fix the contrib apps paths
- Macrofied!

* Tue May 07 2002 Jason Corley <Jason.Corley@TogetherSoft.com>
- Updated to 16.1f
- Removed sample structure from /etc/cvsupd

* Mon Jan 21 2002 Jason Corley <Jason.Corley@TogetherSoft.com>
- Added the license file, changelogs, etc. into /usr/share/doc

* Thu Jan 17 2002 Jason Corley <Jason.Corley@TogetherSoft.com>
- Updated build requirements to use ezm3 instead of all those little pm3 RPMs

* Thu Dec 27 2001 Jason Corley <Jason.Corley@TogetherSoft.com>
- Updated for 16.1e
- Added the /etc/cvsupd directory and created a sample structure for it
- Added rc and logrotate scripts to the package
- Added a pre-uninstall script
- Added a little paranoia check to the clean script

* Tue Sep 11 2001 David Woodhouse <dwmw2@infradead.org>
- Initial build.
